/**
 * Copyright (c) 2008-2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the New BSD License (3-clause license).
 *
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the New BSD License (3-clause license)
 * for more details.
 *
 * You should have received a copy of the New BSD License (3-clause license)
 * along with this program/library; If not, see http://directory.fsf.org/wiki/License:BSD_3Clause/
 * for the New BSD License (3-clause license).
 */
 
package org.ow2.easywsdl.schema.api;

/**
 * This interface represents an documentation, and contains the content of the input and the message itself.
 * @author Nicolas Salatge - EBM WebSourcing
 */
public interface Documentation extends SchemaElement {
    /**
     * Set the content of this documentation.
     * 
     * @param content
     *            the content
     */
    void setContent(String content);

    /**
     * Get the content of this documentation.
     * 
     * @return the content
     */
    String getContent();

}
